-- Version 1.1
-- 6 March 2023

TAG_SHOE =		"trolleyShoe"
TAG_CHECK =		"trolleyCheck"
TAG_CONNECT =	"trolleyConnect"
TAG_CAPTURE	=	"trolleyCapture"

function init()
	checkTrigger = FindTrigger(TAG_CHECK)
	captureTrigger = FindTrigger(TAG_CAPTURE)
	captureBody = FindBody(TAG_CAPTURE)
	captureNodes = FindShapes(TAG_CAPTURE)
	checkTriggerTrans = GetTriggerTransform(checkTrigger)
	captureTriggerTrans = GetTriggerTransform(captureTrigger)
	captureBodyTrans = GetBodyTransform(captureBody)
	checkTriggerLoc = TransformToLocalTransform(captureBodyTrans, checkTriggerTrans)
	captureTriggerLoc = TransformToLocalTransform(captureBodyTrans, captureTriggerTrans)

	enteredList = {}
end

function tick()
	if IsBodyActive(captureBody) then
		captureBodyTrans = GetBodyTransform(captureBody)
		checkTriggerNew = TransformToParentTransform(captureBodyTrans, checkTriggerLoc)
		captureTriggerNew = TransformToParentTransform(captureBodyTrans, captureTriggerLoc)
		SetTriggerTransform(checkTrigger, checkTriggerNew)
		SetTriggerTransform(captureTrigger, captureTriggerNew)
	end
	shoeShapes = FindShapes(TAG_CONNECT, true)
	checkTriggerPos = GetTriggerTransform(checkTrigger).pos
	for i, shape in ipairs(shoeShapes) do
		if IsShapeInTrigger(captureTrigger, shape) then
			local poleCentre = GetBodyTransform(GetShapeBody(shape)).pos
			local closetDist = GetTriggerDistance(checkTrigger, poleCentre)
			local furthestPoint = GetTriggerClosestPoint(checkTrigger, VecLerp(poleCentre, checkTriggerPos, 2))
			local furthestDist = VecLength(VecSub(poleCentre, furthestPoint))
			local poleLength = VecLength(VecSub(GetShapeCenter(shape), poleCentre))
			if (closetDist < poleLength) and (poleLength < furthestDist) then
				enteredList[shape] = shape
				SetTag(shape, TAG_CONNECT, "_"..table.concat(captureNodes, "_"))
			else
				enteredList[shape] = 0
				SetTag(shape, TAG_CONNECT, "")
			end
		end
	end
	local newList = {}
	for i, shape in pairs(enteredList) do
		if not IsShapeInTrigger(captureTrigger, shape) then
			SetTag(shape, TAG_CONNECT, "")
		else
			newList[shape] = shape
		end
	end
	enteredList = newList
end

function GetShapeCenter(shape)
	local min, max = GetShapeBounds(shape)
	return VecLerp(min, max, 0.5)
end